<?

//Film-Datenbank mit automatischer Abfrage der Internet Movie Database
//(c) Copyright Thiemo Mttig, thiemo.maettig@web.de
//Kommerzielle Verwendung dieses Skriptes ist strengstens untersagt!

//Hier den Dateinamen der Datendatei angeben
//Datenformat: Titel,Originaltitel,Sprache,Genre,Produktionsland,Jahr,FSK,Rating
$database = 'filme.txt';

//----------------------------------------------------------------------------

//Die komplette Datendatei einlesen und im Array $film ablegen
function db_einlesen()
{
  global $database, $film;
  if ($film = @file($database))
  {
    for ($i = 0; $i < count($film); $i++)
    {
      $film[$i] = explode("\t", chop($film[$i]));
    }
  }
  else unset($film);
}

//----------------------------------------------------------------------------

//Die Datendatei speichern, sie wird dabei vollstaendig neu erzeugt
function db_schreiben()
{
  global $database, $film, $sort, $sortierrichtung;

  $sort = 0;
  $sortierrichtung = 1;
  usort($film, 'cmp');

  $fp = fopen($database, 'w');
  flock($fp, 2);
  for ($i = 0; $i < count($film); $i++)
  {
    if ($film[$i][0]) fputs($fp, implode("\t", $film[$i]) . "\n");
  }
  fclose($fp);
}

//----------------------------------------------------------------------------

//Hilfsfunktion fuer das benutzerdefinierte Sortieren mittels "usort"
function cmp($a, $b)
{
  global $sort, $sortierrichtung;
  $v_a = strtr(strtolower($a[$sort]), array(''=>'ae', ''=>'oe', ''=>'ue'));
  $v_b = strtr(strtolower($b[$sort]), array(''=>'ae', ''=>'oe', ''=>'ue'));
  if ($v_a == $v_b) return 0;
  return $v_a > $v_b ? $sortierrichtung : -1 * $sortierrichtung;
}

//----------------------------------------------------------------------------

//Anzeige des Formulares und der Liste zum Editieren der Datenbank
function liste_dynamisch()
{
  global $PHP_SELF, $film, $id, $imdb, $action, $neu, $sort, $sortierrichtung;
  $id = $id - 1;

  echo "<form action=\"$PHP_SELF\" method=post><pre>";
  echo "<input type=hidden name=\"id\" value=\"" . ($id + 1) . "\">";
  echo "        Titel: <input type=text name=\"neu[]\" size=50 value=\"" . $film[$id][0] . "\">";
  if ($imdb)
    echo " [ <a href=\"http://german.imdb.com/Title?$imdb\" target=\"_blank\">zur IMDb gehen</a> ]\n";
  else
    echo " <input type=submit name=\"action\" value=\"IMDb abfragen\">\n";
  echo "Originaltitel: <input type=text name=\"neu[]\" size=50 value=\"".$film[$id][1]."\">\n";
  echo "      Sprache: <select name=\"neu[]\" size=1><option value=\"\"";
  if(!$film[$id][2]) echo " selected";
  echo ">deutsch<option value=\"E\"";
  if($film[$id][2]=='E') echo " selected";
  echo ">englisch</select>\n";
  echo "        Genre: <input type=text name=\"neu[]\" size=50 value=\"".$film[$id][3]."\">\n";
  echo "         Land: <input type=text name=\"neu[]\" size=50 value=\"".$film[$id][4]."\">\n";
  echo "         Jahr: <input type=text name=\"neu[]\" size=4 value=\"".$film[$id][5]."\">";
  echo "  FSK: <input type=text name=\"neu[]\" size=2 value=\"".$film[$id][6]."\">";
  echo "  Wertung: <input type=text name=\"neu[]\" size=3 value=\"".$film[$id][7]."\">";
  echo "  <input type=submit name=\"action\" value=\"Eintragen\">";
  if ($id >= 0) echo " <input type=submit name=\"action\" value=\"Reset\">";
  echo "</pre></form>";

  echo "<p>[ <a href=\"$PHP_SELF?statisch=plain\">filme.txt</a> | ";
  echo "<a href=\"$PHP_SELF?statisch=html\">filme.html</a> ]</p>";

  echo "<table width=\"100%\" border=1 cellspacing=0 cellpadding=1>\n";
  echo "<tr><th align=left><a href=\"$PHP_SELF?sort=0\">Titel</a> (Originaltitel)</th>";
  echo "<th><a href=\"$PHP_SELF?sort=2\">S.</a></th>";
  echo "<th align=left>Genre</th>";
  echo "<th align=left>Land</th>";
  echo "<th><a href=\"$PHP_SELF?sort=5\">Jahr</a></th>";
  echo "<th align=right>FSK</th>";
  echo "<th align=right><a href=\"$PHP_SELF?sort=7\">Wertung</a></th></tr>\n";

  switch ($sort = (int)$sort)
  {
    case 5: $sortierrichtung = -1; break;
    case 7: $sortierrichtung = -1; break;
    default: $sortierrichtung = 1; break;
  }
  uasort($film, 'cmp');
  reset($film);

  //Die Tabelle mit allen Filmen erzeugen
  while (list($key, $row) = each($film))
  {
    echo '<tr>';
    echo '<td><a href="' . $PHP_SELF . '?id=' . ($key + 1) . '">' . $row[0] . '</a>';
    if ($row[1]) echo ' (' . $row[1] . ')';
    echo '</td>';
    echo '<td align=center>';
    if ($row[2] == 'E') echo 'e'; else echo 'd';
    echo '</td>';
    echo '<td>' . substr($row[3], 0, 25);
    if (strlen($row[3]) > 25) echo '...';
    echo '</td>';
    echo '<td>' . substr($row[4], 0, 25);
    if (strlen($row[4])>25) echo '...';
    echo '</td>';
    echo '<td align=center>' . $row[5]  .'</td>';
    echo '<td align=right>';
    if ($row[6]) echo $row[6]; else echo '&nbsp;';
    echo '</td>';
    echo '<td align=right>';
    if ($row[7]) echo $row[7] . '/10'; else echo '&nbsp;';
    echo '</td>';
    echo "</tr>\n";
  }
  echo "</table>\n";
}

//----------------------------------------------------------------------------

//Die Liste in Textform erzeugen, im Browser dann "Speichern unter" benutzen
function liste_plain()
{
  global $film, $sort, $sortierrichtung;

  header('Content-Type: text/plain');
  $trenner = "-------------------------------------------------------------------------------\n";
  echo $trenner;
  echo "Filmtitel                    Sprache  Genre                   Land Jahr FSK  *1\n";
  echo $trenner;

  $sort = 0; $sortierrichtung = 1; uasort($film, 'cmp');
  reset($film);

  //Datenformat: Titel,Originaltitel,Sprache,Genre,Land,Jahr,FSK,Wertung
  while (list($key, $row) = each($film))
  {
    $a = strtr(strtolower($row[0][0]), '', 'aou');
    if ($a >= 'a' && $a != $aa) { echo $trenner; $aa = $a; }

    $z = substr("$row[0]                                 ", 0, 33);
    if ($row[2] == 'E') $z .= "  e  "; else $z .= "  d  ";
    preg_match('/^.{0,20}[^\/]{3}/i', $row[3], $match);
    $z .= substr("$match[0]                       ", 0, 23) . "  ";
    $z .= strtr(substr("$row[4]   ", 0, 3), '/', ' ') . "  ";
    $z .= substr("  $row[5]", -2);
    $z .= substr("    $row[6]", -4);
    $z .= substr("     $row[7]", -5);
    echo rtrim($z)."\n";
  }
  echo $trenner;
  echo "\n*1) Nutzerbewertungen der Internet Movie Database (http://www.imdb.de)";
  echo "\n    von 1 (katastrophal) bis 10 (herausragend)\n";
}

//----------------------------------------------------------------------------

//Die Liste in HTML-Form erzeugen, ebenfalls mit "Speichern unter" abspeichern
function liste_html()
{
  global $PHP_SELF, $ready, $email, $unkosten, $originaltitel, $film, $sort, $sortierrichtung;

  //Vorher koennen noch einige Einstellungen fuer die Liste getroffen werden
  if (! $ready)
  {
    echo "<form action=\"".$PHP_SELF."\" method=post><pre>";
    echo "        E-Mail-Adresse: <input type=text name=\"email\"> (optionale Angabe)\n";
    echo "Unkostenbeitrag pro CD: <input type=text name=\"unkosten\"> Euro (optionale Angabe)\n";
    echo "                        <input type=checkbox name=\"originaltitel\"> Originaltitel anzeigen\n";
    echo "                        <input type=submit name=\"ready\" value=\"Liste erzeugen\">";
    echo "<input type=hidden name=\"statisch\" value=\"html\">";
    echo "</pre></form>";
    //Abbruch, also die Liste jetzt noch nicht anzeigen
    exit;
  }

  echo "<html>\n<head>\n<title>Filme</title>\n</head>\n";
  echo "</body bgcolor=\"#ffffff\">\n\n";
  echo "<h1>Filme</h1>\n\n";
  if ($email)
    echo "<form action=\"mailto:$email\" method=post enctype=\"text/plain\">\n";
  echo "<table width=\"100%\" border=1 cellspacing=0 cellpadding=2>\n";
  echo "<tr>";
  if ($email) echo "<th></th>";
  echo "<th align=left>Filmtitel</th><th>S.</th><th align=left>Genre</th><th align=left>Land</th><th>Jahr</th><th>FSK</th><th align=right>*1)</th></tr>\n";

  $sort = 0; $sortierrichtung = 1; uasort($film, 'cmp');
  reset($film);

  //Erzeugen der HTML-Liste, eventuell mit Checkbox vor jeder Zeile
  while (list($key, $row) = each($film))
  {
    echo "<tr>";
    if ($email)
    {
      echo "<td><input type=checkbox name=\"Film\" value=\"$row[0]";
      if ($row[2] == 'E') echo " (englisch)";
      echo "\"";
      if ($unkosten)
        echo " onClick=\"this.form.Preis.value=(this.checked?$unkosten:-$unkosten)+1*this.form.Preis.value;\"";
      echo "></td>\n";
    }
    echo "<td>$row[0]";
    if ($originaltitel && $row[1]) echo " ($row[1])";
    echo "</td>";
    echo "<td align=center>", $row[2] == 'E' ? "e" : "d" ,"</td>";
    preg_match('/^((\/?[^\/]+){0,3})/i', $row[3], $match);
    echo "<td>", $match[1] ? $match[1] : "&nbsp;", "</td>";
    preg_match('/^((\/?[^\/]+){0,2})/i', $row[4], $match);
    echo "<td>", $match[1] ? $match[1] : "&nbsp;", "</td>";
    echo "<td align=center>", $row[5] ? $row[5] : "&nbsp;", "</td>";
    echo "<td align=right>", $row[6] ? $row[6] : "&nbsp;", "</td>";
    echo "<td align=right>", $row[7] ? $row[7] : "&nbsp;", "</td>";
    echo "</tr>\n";
  }
  echo "</table>\n\n";
  if ($email && $unkosten)
    echo "<p>Unkostenbeitrag: <input type=text size=4 name=\"Preis\" value=\"0\" readonly> Euro</p>\n";
  if ($email)
    echo "<p><input type=submit value=\"E-Mail abschicken\"></p>\n";
  echo "</form>\n";
  echo "<p><b>*1)</b> Nutzerbewertungen der <a href=\"http://www.imdb.de/\">Internet Movie Database</a>";
  echo " von 1 (katastrophal) bis 10 (herausragend)</p>\n";
}

//----------------------------------------------------------------------------

db_einlesen();

if ($action == 'Reset')
{
  //Kompletter Reset des Formulares
  unset($id);
}
elseif ($action == 'Eintragen')
{
  //Abspeichern des aktuellen Eintrages in der Datendatei
  //Vorher werden diverse automatische Korrekturen vorgenommen

  $trans = array('Comedy'=>'Komdie', 'Adventure'=>'Abenteuer', 'Romance'=>'Romanze', 'Crime'=>'Krimi', 'Family'=>'Familie', 'War'=>'Krieg');
  $neu[3] = strtr($neu[3], $trans);
  $trans=array('usa'=>'USA', 'Germany'=>'Deutschland', 'Canada'=>'Kanada', 'France'=>'Frankreich', 'Switzerland'=>'Schweiz', 'Australia'=>'Australien');
  $neu[4] = strtr($neu[4], $trans);
  if (strtolower($neu[4]) == 'd') $neu[4] = 'Deutschland';
  if ($neu[5] < 20) $neu[5] += 2000;
  elseif ($neu[5] < 100) $neu[5] += 1900;
  $neu[7] = strtr($neu[7], '.', ',');
  for ($i = 0; $i < count($neu); $i++)
  {
    $neu[$i] = preg_replace('| */ *|', '/', trim(stripslashes($neu[$i])));
  }
  
  if($id > 0) $film[$id - 1] = $neu;
  else $film[count($film)] = $neu;
  db_schreiben();
  if (! $neu[0]) unset($film[$id - 1]);
  unset($id);
}
elseif ($action == 'IMDb abfragen' || $imdb)
{
  //Falls die Kennnummer eines Filmes eingegeben wurde, diesen direkt abfragen
  if (preg_match('/^\d+$/', $neu[0])) $imdb = $neu[0];

  if ($imdb)
  {
    //Aufruf der Informationen zu einem speziellen Film
    $s = @implode('', file('http://german.imdb.com/Title?' . $imdb));
  }
  else
  {
    //Aufruf der Suchfunktion
    //Redirection wird nicht unterstuetzt, in diesem Fall muss man die
    //Kennummer manuell holen und im Feld "Titel" eintragen!
    $s = @file('http://german.imdb.com/Find?select=Titles&for='.urlencode($neu[0]));
    if ($s) $s = implode('', $s);
    else
      echo "<p>[ <a href=\"http://german.imdb.com/Find?select=Titles&for=".urlencode($neu[0])."\" target=\"_blank\">zur IMDb gehen</a> ] (Die Kennnummer des Filmes dann im Titel-Feld eintragen.)</p>\n";
  }

  //Falls die erhaltene Seite ein Suchergebnis darstellt, dieses anzeigen
  if (preg_match('|<H1>Titelsuche</H1>|i', $s))
  {
    preg_match('|(<H2>.+?</H2>.*?<OL>.+?</OL>[\r\n]*)+|is', $s, $match);
    $s = $match[0];
    $s = preg_replace('|HREF="/Title\?(\d+)"|im', "href=\"$PHP_SELF?imdb=\\1&id=$id\"", $s);
    echo '<table width="100%" border=1 cellspacing=0 cellpadding=6><tr><td>';
    echo $s . '</td></tr></table>';
  }
  //Ansonsten versuchen, aus der Seite alle Informationen heraus zu holen
  else
  {
    preg_match('/>([^<>]*?) *\(?\d*\)? *(\(Austria\))? *\((West )?Germany\)/im',$s,$match);
    $film[$id - 1][0] = $match[1];

    preg_match('/<TITLE>(.*?) *\(?\d*\)?<\/TITLE>/im', $s, $match);
    $film[$id - 1][1] = $match[1];
    if (! $film[$id - 1][0])
    {
      $film[$id - 1][0] = $match[1];
      $film[$id - 1][1] = '';
    }

    preg_match('/Genre<\/B>: ((<A.*?[^)]<\/A> *\/? *)+)/im', $s, $match);
    $match[1] = preg_replace('/<[^>]*>/i', '', $match[1]);
    $film[$id - 1][3] = $match[1];

    preg_match('/Produktionsland<\/B>: ((<A.*?<\/A> *\/? *)+)/im',$s,$match);
    $match[1] = preg_replace('/<[^>]*>/i', '', $match[1]);
    $film[$id - 1][4] = $match[1];

    preg_match('/\((19\d\d|20\d\d)\)/im', $s, $match);
    $film[$id - 1][5] = $match[1];

    preg_match('/">Germany: *(\d+)/im', $s, $match);
    $film[$id - 1][6] = $match[1];

    preg_match('/<B>(\d+\.\d+)<\/B>\/10/im', $s, $match);
    $film[$id - 1][7] = $match[1];
  }
}

if ($statisch == 'plain') liste_plain();
elseif ($statisch == 'html') liste_html();
else liste_dynamisch();

?>